/***************************************************************************
                          CalcInternal.h  -  description
                             -------------------
    begin                : Sat Nov 18 2000
    copyright            : (C) 2000 by Gyorgy Molnar
    email                : lindev@home.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "Table.h"


KeyTokens tableNorm[42] =
{
  tc2nd, tcHex, tcDec, tcOct, tcBin, tcNull,
  tcXy,  tcLn,  tcLog, tcSin, tcCos, tcTan,
  tcX2,  tcX3,  tcPl,  tcPr,  tcX1,  tcBsp,
  tcM,   tc1,   tc2,   tc3,   tcDiv, tcCe,
  tcMp,  tc4,   tc5,   tc6,   tcMul, tcAc,
  tcMr,  tc7,   tc8,   tc9,   tcSub, tcFe,
  tcMc,  tcMin, tc0,   tcDot, tcAdd, tcEq,
};

KeyTokens table2nd[42] =
{
  tc2nd, tcDeg, tcRad, tcGrad,tcNull,tcNull,
  tcYvx, tcEx,  tc10x, tcAsin,tcAcos,tcAtan,
  tc2vx, tc3vx, tcNull,tcNull,tcNull,tcNull,
  tcPi,  tcEe,  tcNull,tcNull,tcNull,tcNull,
  tcNull,tcNull,tcNull,tcNull,tcNull,tcNull,
  tcNull,tcNull,tcNull,tcNull,tcNull,tcExp,
  tcNull,tcEmin,tcNull,tcFix, tcNull,tcNull
};
KeyTokens tableBaseNNorm[] =
{
  tcNull,tcHex, tcDec, tcOct, tcBin, tcTab,
  tcA,   tcB,   tcC,   tcD,   tcE,   tcF,
  tcNull,tcNeg, tcAnd, tcOr,  tcXor, tcBsp,
  tcM,   tc1,   tc2,   tc3,   tcDiv, tcCe,
  tcMp,  tc4,   tc5,   tc6,   tcMul, tcAc,
  tcMr,  tc7,   tc8,   tc9,   tcSub, tcMod,
  tcMc,  tcNull,tc0,   tcNull,tcAdd, tcEq,
};

KeyTokens tableBaseN2nd[42] =
{
  tcNull,tcNull,tcNull,tcNull,tcNull,tcNull,
  tcNull,tcNull,tcNull,tcNull,tcNull,tcNull,
  tcNull,tcNull,tcNull,tcNull,tcNull,tcNull,
  tcNull,tcNull,tcNull,tcNull,tcNull,tcNull,
  tcNull,tcNull,tcNull,tcNull,tcNull,tcNull,
  tcNull,tcNull,tcNull,tcNull,tcNull,tcNull,
  tcNull,tcNull,tcNull,tcNull,tcNull,tcNull,
};

struct Priority
{
  KeyTokens tcOp;
  int       iPryLevel;
} PryList[8] =
{
  {tcXy,   5},
  {tcYvx,  5},
  {tcDiv,  3},
  {tcMul,  3},
  {tcMod,  3},
  {tcSub,  1},
  {tcAdd,  1},
  {tcNull, 0}
};

struct PriorityInt
{
  KeyTokens tcOp;
  int       iPryLevel;
} PryListInt[9] =
{
  {tcDiv,  4},
  {tcMul,  4},
  {tcMod,  4},
  {tcSub,  3},
  {tcAdd,  3},
  {tcAnd,  2},
  {tcXor,  1},
  {tcOr,   0},
  {tcNull, 0}
};

typedef struct _StackDoubleItem
{
  double dNumber;
  KeyTokens tcOp;
} StackDoubleItem;

typedef struct _StackIntItem
{
  int iNumber;
  KeyTokens tcOp;
} StackIntItem;
