/***************************************************************************
                          Disp.h  -  description
                             -------------------
    begin                : Thu Dec 7 2000
    copyright            : (C) 2000 by Gyorgy Molnar
    email                : lindev@home.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

struct _SegmentLine
{
  int   x1; int   y1; int   x2; int   y2;
};
typedef struct _SegmentLine SegmentLine;


//    00000
//    5   1
//    5   1
//    66666
//    4   2
//    4   2
//    33333

// disp size 0,0 240,25
// digit size 0,0, 11, 19

SegmentLine seg0[3] =
{
    {0, 0,  9, 0},
    {1, 1,  8, 1},
    {2, 2,  7, 2}
};
SegmentLine seg1[3] =
{
    { 8, 2,  8, 7},
    { 9, 1,  9, 8},
    {10, 0, 10, 8}
};
SegmentLine seg2[3] =
{
    { 8, 11,  8, 17},
    { 9, 10,  9, 18},
    {10,  9, 10, 19}
};
SegmentLine seg3[3] =
{
    {0, 19,  9, 19},
    {1, 18,  8, 18},
    {2, 17,  7, 17}
};
SegmentLine seg4[3] =
{
    {0,  9, 0, 18},
    {1, 10, 1, 17},
    {2, 11, 2, 16}
};
SegmentLine seg5[3] =
{
    {0,  1, 0, 8},
    {1,  2, 1, 8},
    {2,  3, 2, 7}
};
SegmentLine seg6[3] =
{
    {2,  8,   8,  8},
    {1,  9,   9,  9},
    {2, 10,   8, 10}
};
SegmentLine * Segments[7] =
{
  seg0, seg1, seg2, seg3, seg4, seg5,seg6
};

int iCharToInt[17] =
{
  0x3f, // 0
  0x06, // 1
  0x5b, // 2
  0x4f, // 3
  0x66, // 4
  0x6d, // 5
  0x7d, // 6
  0x07, // 7
  0x7f, // 8
  0x6f, // 9
  0x77, // a
  0x7c, // b
  0x39, // c
  0x5e, // d
  0x79, // e
  0x71, // f
  0x50, // r
};

int iD[76]=
{
  1, 1, 1, 2, 1, 3, 1, 4, 1, 5, 1, 6, 1, 7, 1, 8,
  2, 1, 2, 2, 2, 3, 2, 4, 2, 5, 2, 6, 2, 7, 2, 8,
  3, 1, 3, 2, 3, 7, 3, 8,
  4, 1, 4, 2, 4, 7, 4, 8,
  5, 1, 5, 2, 5, 3, 5, 4, 5, 5, 5, 6, 5, 7, 5, 8,
  6, 2, 6, 3, 6, 4, 6, 5, 6, 6, 6, 7
};
int iH[72]=
{
  1, 1, 1, 2, 1, 3, 1, 4, 1, 5, 1, 6, 1, 7, 1, 8,
  2, 1, 2, 2, 2, 3, 2, 4, 2, 5, 2, 6, 2, 7, 2, 8,
  3, 4, 3, 5,
  4, 4, 4, 5,
  5, 1, 5, 2, 5, 3, 5, 4, 5, 5, 5, 6, 5, 7, 5, 8,
  6, 1, 6, 2, 6, 3, 6, 4, 6, 5, 6, 6, 6, 7, 6, 8
};
int iO[72]=
{
  1, 2, 1, 3, 1, 4, 1, 5, 1, 6, 1, 7,
  2, 1, 2, 2, 2, 3, 2, 4, 2, 5, 2, 6, 2, 7, 2, 8,
  3, 1, 3, 2, 3, 7, 3, 8,
  4, 1, 4, 2, 4, 7, 4, 8,
  5, 1, 5, 2, 5, 3, 5, 4, 5, 5, 5, 6, 5, 7, 5, 8,
  6, 2, 6, 3, 6, 4, 6, 5, 6, 6, 6, 7
};
int iB[80]=
{
  1, 1, 1, 2, 1, 3, 1, 4, 1, 5, 1, 6, 1, 7, 1, 8,
  2, 1, 2, 2, 2, 3, 2, 4, 2, 5, 2, 6, 2, 7, 2, 8,
  3, 1, 3, 2, 3, 4, 3, 5, 3, 7, 3, 8,
  4, 1, 4, 2, 4, 4, 4, 5, 4, 7, 4, 8,
  5, 1, 5, 2, 5, 3, 5, 4, 5, 5, 5, 6, 5, 7, 5, 8,
  6, 2, 6, 3, 6, 6, 6, 7
};
int iR[76]=
{
  1, 1, 1, 2, 1, 3, 1, 4, 1, 5, 1, 6, 1, 7, 1, 8,
  2, 1, 2, 2, 2, 3, 2, 4, 2, 5, 2, 6, 2, 7, 2, 8,
  3, 1, 3, 2, 3, 4, 3, 5,
  4, 1, 4, 2, 4, 4, 4, 5, 4, 6,
  5, 1, 5, 2, 5, 3, 5, 4, 5, 5, 5, 6, 5, 7, 5, 8,
  6, 2, 6, 3, 6, 4, 6, 7, 6, 8
};
int iG[80]=
{
  1, 1, 1, 2, 1, 3, 1, 4, 1, 5, 1, 6, 1, 7, 1, 8,
  2, 1, 2, 2, 2, 3, 2, 4, 2, 5, 2, 6, 2, 7, 2, 8,
  3, 1, 3, 2, 3, 7, 3, 8,
  4, 1, 4, 2, 4, 4, 4, 5, 4, 7, 4, 8,
  5, 1, 5, 2, 5, 4, 5, 5, 5, 6, 5, 7, 5, 8,
  6, 1, 6, 2, 6, 4, 6, 5, 6, 6, 6, 7, 6, 8,
};
int iN[76]=
{
  1, 1, 1, 2, 1, 3, 1, 4, 1, 5, 1, 6, 1, 7, 1, 8,
  2, 1, 2, 2, 2, 3, 2, 4, 2, 5, 2, 6, 2, 7, 2, 8,
        3, 2, 3, 3, 3, 4,
                          4, 5, 4, 6, 4, 7,
  5, 1, 5, 2, 5, 3, 5, 4, 5, 5, 5, 6, 5, 7, 5, 8,
  6, 1, 6, 2, 6, 3, 6, 4, 6, 5, 6, 6, 6, 7, 6, 8
};
int iF[56]=
{
  1, 1, 1, 2, 1, 3, 1, 4, 1, 5, 1, 6, 1, 7, 1, 8,
  2, 1, 2, 2, 2, 3, 2, 4, 2, 5, 2, 6, 2, 7, 2, 8,
  3, 1, 3, 2, 3, 4, 3, 5,
  4, 1, 4, 2, 4, 4, 4, 5,
  5, 1, 5, 2,
  6, 1, 6, 2,
};
int iS[72]=
{
  1, 2, 1, 3, 1, 4, 1, 7, 1, 8,
  2, 1, 2, 2, 2, 3, 2, 4, 2, 5, 2, 7, 2, 8,
  3, 1, 3, 2, 3, 4, 3, 5, 3, 7, 3, 8,
  4, 1, 4, 2, 4, 4, 4, 5, 4, 7, 4, 8,
  5, 1, 5, 2, 5, 4, 5, 5, 5, 6, 5, 7, 5, 8,
  6, 1, 6, 2, 6, 5, 6, 6, 6, 7,
};
int i0[64]=
{
        1, 2, 1, 3, 1, 4, 1, 5, 1, 6, 1, 7,
  2, 1, 2, 2, 2, 3, 2, 4, 2, 5, 2, 6, 2, 7, 2, 8,
  3, 1, 3, 2,                         3, 7, 3, 8,
  4, 1, 4, 2, 4, 3, 4, 4, 4, 5, 4, 6, 4, 7, 4, 8,
        5, 2, 5, 3, 5, 4, 5, 5, 5, 6, 5, 7,
};
int i1[44]=
{

        2, 2, 2, 3,                   2, 7, 2, 8,
  3, 1, 3, 2, 3, 3, 3, 4, 3, 5, 3, 6, 3, 7, 3, 8,
  4, 1, 4, 2, 4, 3, 4, 4, 4, 5, 4, 6, 4, 7, 4, 8,
                                      5, 7, 5, 8,
};
int i2[58]=
{
        1, 2, 1, 3,             1, 6, 1, 7, 1, 8,
  2, 1, 2, 2, 2, 3,       2, 5, 2, 6, 2, 7, 2, 8,
  3, 1, 3, 2,             3, 5,       3, 7, 3, 8,
  4, 1, 4, 2, 4, 3, 4, 4, 4, 5,       4, 7, 4, 8,
        5, 2, 5, 3, 5, 4,             5, 7, 5, 8,
};
int i3[56]=
{
  1, 1, 1, 2,                   1, 6, 1, 7,
  2, 1, 2, 2,                   2, 6, 2, 7, 2, 8,
  3, 1, 3, 2,       3, 4,             3, 7, 3, 8,
  4, 1, 4, 2, 4, 3, 4, 4, 4, 5, 4, 6, 4, 7, 4, 8,
  5, 1, 5, 2, 5, 3,       5, 5, 5, 6, 5, 7,
};
int i4[48]=
{
  1, 1, 1, 2, 1, 3, 1, 4, 1, 5, 1, 6,
  2, 1, 2, 2, 2, 3, 2, 4, 2, 5, 2, 6,
                          3, 5, 3, 6,
                    4, 4, 4, 5, 4, 6, 4, 7, 4, 8,
                    5, 4, 5, 5, 5, 6, 5, 7, 5, 8
};
int i5[62]=
{
  1, 1, 1, 2, 1, 3, 1, 4, 1, 5,       1, 7,
  2, 1, 2, 2, 2, 3, 2, 4, 2, 5,       2, 7, 2, 8,
  3, 1, 3, 2,       3, 4, 3, 5,       3, 7, 3, 8,
  4, 1, 4, 2,       4, 4, 4, 5, 4, 6, 4, 7, 4, 8,
  5, 1, 5, 2,             5, 5, 5, 6, 5, 7,
};
int i6[62]=
{
        1, 2, 1, 3, 1, 4, 1, 5, 1, 6, 1, 7,
  2, 1, 2, 2, 2, 3, 2, 4, 2, 5, 2, 6, 2, 7, 2, 8,
  3, 1, 3, 2,       3, 4, 3, 5,       3, 7, 3, 8,
  4, 1, 4, 2,       4, 4, 4, 5, 4, 6, 4, 7, 4, 8,
        5, 2,             5, 5, 5, 6, 5, 7,
};


