/***************************************************************************
                          event.c  -  description
                             -------------------
    begin                : Wed Nov 15 2000
    copyright            : (C) 2000 by Gyorgy Molnar
    email                : lindev@home.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <gtk/gtk.h>
#include <string.h>
#include <stdlib.h>
#include "Disp.h"
#include "event.h"
#include "Calc.h"

GtkWidget * lpWin = NULL;
GtkWidget * lpFixed = NULL;
GtkWidget * lpDisplay = NULL;

GdkColor    Colors[3];

int GetSegMask(char ch)
{
  if(ch >= '0' && ch <= '9')
    return iCharToInt[(int)(ch - '0')];
  if(ch >= 'A' && ch <= 'F')
    return iCharToInt[(int)(ch - 'A') + 10];
  if(ch >= 'a' && ch <= 'f')
    return iCharToInt[(int)(ch - 'a') + 10];
  if(ch == 'r' || ch == 'R')
    return iCharToInt[16];
  return iCharToInt[16];
}

void PutChar(GdkGC * lpGC, char ch, int iPos)
{
  int iX = 221 - iPos * 18;
  int iY = 3;
  int i, iNum = GetSegMask(ch);
  for(i = 0; i < 7; i++)
  {
    if(iNum & 0x01)
    {
      gdk_draw_line(GTK_WIDGET(lpDisplay)->window, lpGC,
        Segments[i][0].x1+iX, Segments[i][0].y1+iY,
        Segments[i][0].x2+iX, Segments[i][0].y2+iY);
      gdk_draw_line(GTK_WIDGET(lpDisplay)->window, lpGC,
        Segments[i][1].x1+iX, Segments[i][1].y1+iY,
        Segments[i][1].x2+iX, Segments[i][1].y2+iY);
      gdk_draw_line(GTK_WIDGET(lpDisplay)->window, lpGC,
        Segments[i][2].x1+iX, Segments[i][2].y1+iY,
        Segments[i][2].x2+iX, Segments[i][2].y2+iY);
    }
    iNum >>= 1;
  }
}

void PutDecPoint(GdkGC * lpGC, int iPos)
{
  if(iPos <= 11 && iPos >= 0)
  {
    int iX = 234 - iPos * 18;
    gdk_draw_rectangle(GTK_WIDGET(lpDisplay)->window, lpGC, TRUE, iX, 20, 3, 4);
  }
}

void PutTab(int iTab, int iTabMax)
{
  if(iTabMax > 0)
  {
    GdkGC * lpGC;
    int y, h;
    y = (int)(15.0 / iTabMax * (iTabMax - iTab - 1));
    h = (int)(15.0 / iTabMax) + 1;
    if((lpGC  = gdk_gc_new(lpDisplay->window)) == NULL)
      return;
    gdk_gc_set_foreground(lpGC, Colors + 1);
    gdk_draw_rectangle(GTK_WIDGET(lpDisplay)->window, lpGC, FALSE, 235, 3, 5, 15);
    gdk_draw_rectangle(GTK_WIDGET(lpDisplay)->window, lpGC, TRUE,  235, 3 + y, 5, h);
    gdk_gc_unref(lpGC);
  }
}

void PutSign(GdkGC * lpGC, int iPos)
{
  int iX = 233 - iPos * 18;
  gdk_draw_rectangle(GTK_WIDGET(lpDisplay)->window, lpGC, TRUE, iX, 10, 5, 3);
}

void Put2nd(int i2nd)
{
  if(i2nd)
  {
    GdkGC * lpGC;
    if((lpGC  = gdk_gc_new(lpDisplay->window)) == NULL)
      return;
    gdk_gc_set_foreground(lpGC, Colors);
    gdk_draw_rectangle(GTK_WIDGET(lpDisplay)->window, lpGC, TRUE, 2, 20, 6, 4);
    gdk_gc_unref(lpGC);
  }
}

void PutMode(GdkGC * lpGC, int iMode)
{
  int i, x, y;
  x = 1; y = 10;
  switch(iMode)
  {
  case 0:
    for(i = 0; i < 76; i += 2)
      gdk_draw_point(GTK_WIDGET(lpDisplay)->window, lpGC, iD[i] + x, iD[i + 1] + y);
    break;
  case 1:
    for(i = 0; i < 76; i += 2)
      gdk_draw_point(GTK_WIDGET(lpDisplay)->window, lpGC, iR[i] + x, iR[i + 1] + y);
    break;
  case 2:
    for(i = 0; i < 80; i += 2)
      gdk_draw_point(GTK_WIDGET(lpDisplay)->window, lpGC, iG[i] + x, iG[i + 1] + y);
    break;
  default:
    ;
  }
}

void PutFix(GdkGC * lpGC, int iFix)
{
  if(iFix >= 0 && iFix <= 6)
  {
    int i, x, y;
    int * iPix[7]  = {i0, i1, i2, i3, i4, i5, i6};
    int iSize[7]   = {64, 44, 58, 56, 48, 62, 62};
    int * lpPix = iPix[iFix];
    x = 9; y = 1;
    for(i = 0; i < iSize[iFix]; i += 2)
      gdk_draw_point(GTK_WIDGET(lpDisplay)->window, lpGC, *(lpPix + i) + x, *(lpPix + i + 1) + y);
  }
}

void PutExpMode(GdkGC * lpGC, int iE)
{
  if(iE >= 0 && iE <= 2)
  {
    int i, x, y;
    int * iPix[7]  = {iN, iS, iF};
    int iSize[7]   = {76, 72, 56};
    int * lpPix = iPix[iE];
    x = 9; y = 10;
    for(i = 0; i < iSize[iE]; i += 2)
      gdk_draw_point(GTK_WIDGET(lpDisplay)->window, lpGC, *(lpPix + i) + x, *(lpPix + i + 1) + y);
  }
}

void PutBase(int iBase)
{
  GdkGC * lpGC;
  int i, x, y;
  x = 1; y = 1;
  if((lpGC  = gdk_gc_new(lpDisplay->window)) == NULL)
    goto end;
  gdk_gc_set_foreground(lpGC, Colors + 1);
  switch(iBase)
  {
  case 0:
    for(i = 0; i < 72; i += 2)
      gdk_draw_point(GTK_WIDGET(lpDisplay)->window, lpGC, iH[i] + x, iH[i + 1] + y);
    break;
  case 1:
    for(i = 0; i < 76; i += 2)
      gdk_draw_point(GTK_WIDGET(lpDisplay)->window, lpGC, iD[i] + x, iD[i + 1] + y);
    break;
  case 2:
    for(i = 0; i < 72; i += 2)
      gdk_draw_point(GTK_WIDGET(lpDisplay)->window, lpGC, iO[i] + x, iO[i + 1] + y);
    break;
  case 3:
    for(i = 0; i < 80; i += 2)
      gdk_draw_point(GTK_WIDGET(lpDisplay)->window, lpGC, iB[i] + x, iB[i + 1] + y);
    break;
  default:
    ;
  }
  gdk_gc_unref(lpGC);
end:
  return;
}

static char strInfo[] =
"If you have any future question or remarks,\nplease contact lindev@home.com";
static char strHelp[] =
"Hello,\n\n"
"I've been playing around XWindows and decided try to make something usefull while I'm studing.\n"
"To finalize the user interface and to decide the supported operators was a very difficult decision "
"I tried to do my best, but I know it is not perfect. If you have any idea how we can make it better, "
"please contact me. I will also rewrite the code in the near future to make it clear and I want to "
"support all of the features the GNOME can offer to you.\n"
"Unfortunatelly at the moment there are both c and c++ modules in the code. I'm very short of time "
"and I used some existing modules. "
"However, I tried to make clean job at the most inportant part of the program.\n";

void CreateDlg(void)
{
  GtkWidget * lpDlg, *lpLabel, *lpCtrl, * lpText;
  if(!(lpDlg = gtk_dialog_new()))
    goto End;
  if(!(lpLabel = gtk_label_new(strInfo)))
    goto End;
  if(!(lpCtrl = gtk_scrolled_window_new (NULL, NULL)))
    goto End;
  if(!(lpText = gtk_text_new (NULL, NULL)))
    goto End;
  gtk_window_set_policy(GTK_WINDOW(lpDlg), FALSE, FALSE, FALSE);
  gtk_window_set_title(GTK_WINDOW(lpDlg), "About");
  gtk_window_set_modal(GTK_WINDOW(lpDlg), TRUE);
  gtk_widget_ref(lpCtrl);
  gtk_widget_ref(lpText);
  gtk_object_set_data_full(GTK_OBJECT(lpDlg), "Ctrl", lpCtrl,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(lpCtrl), GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);
  gtk_object_set_data_full(GTK_OBJECT(lpDlg), "Text", lpText,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_container_add(GTK_CONTAINER(lpCtrl), lpText);
  gtk_widget_set_usize(lpText, 200, 150);
  GTK_WIDGET_UNSET_FLAGS(lpText, GTK_CAN_FOCUS);
  gtk_text_insert(GTK_TEXT(lpText), NULL, NULL, NULL,
                   strHelp, -1);
  gtk_text_set_word_wrap(GTK_TEXT(lpText), 1);
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(lpDlg)->vbox), lpCtrl, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(lpDlg)->action_area), lpLabel, FALSE, FALSE, 0);
  gtk_widget_show(lpDlg);
  gtk_widget_show(lpText);
  gtk_widget_show(lpLabel);
  gtk_widget_show(lpCtrl);
End:
  return;
}

// ***********************************************************************************

void RefreshDisplay(void)
{
  GdkGC * lpGC;
  int i;
  int iTab, iTabMax, iBase, iMode, iPos, i2nd, iFix, iE;
  char * strDisp = GetDisp(iBase, iMode, iTabMax, iTab, i2nd, iFix, iE);
  if((lpGC  = GTK_WIDGET(lpDisplay)->style->white_gc) == NULL)
    goto end;
  gdk_draw_rectangle(GTK_WIDGET(lpDisplay)->window, lpGC, TRUE, 0, 0, 252, 26);
  if(!strDisp)
    goto end;
  if((lpGC = GTK_WIDGET(lpDisplay)->style->black_gc) == NULL)
    goto end;
  for(iPos = 0, i = strlen(strDisp) - 1; i >= 0 && (iPos < 12 || strDisp[i] == '-'); i--)
  {
    char ch =  strDisp[i];
    if(ch == '+')
      continue;
    if(ch == '.')
    {
      PutDecPoint(lpGC, iPos);
      continue;
    }
    if(ch == '-')
    {
      PutSign(lpGC, iPos);
      continue;
    }
    PutChar(lpGC, ch, iPos++);
  }
  Put2nd(i2nd);
  PutMode(lpGC, iMode);
  PutExpMode(lpGC, iE);
  if(!iE)
    PutFix(lpGC, iFix);
  PutBase(iBase);
  PutTab(iTab, iTabMax);
end:
  return;
}

void Clicked(GtkButton * lpButton, gpointer data)
{
  KeyEvent((int) data);
  RefreshDisplay();
}

void MenuHandler(GtkButton * lpButton, gpointer data)
{
//  g_print("Menu: %02i\n", (int) data);
  if((int)data == MENU_ABOUT)
  {
    CreateDlg();
  }
}

gboolean ShowHandler(GtkWidget * lpWidget, GdkEventExpose * event,
  gpointer data)
{
  RefreshDisplay();
  return TRUE;
}

gboolean KeyHandler(GtkWidget * lpWidget, GdkEventKey * event,
  gpointer data)
{
  if(KeyEvent(event->keyval, 1) >= 0)
    RefreshDisplay();
  return FALSE;
}

gint CanClose(GtkWidget *widget, GdkEvent *event, gpointer data)
{
  gtk_main_quit();
  return(FALSE);
}
