/***************************************************************************
                          interface.c  -  description
                             -------------------
    begin                : Wed Nov 15 2000
    copyright            : (C) 2000 by Gyorgy Molnar
    email                : lindev@home.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>
#include <stdio.h>
#include "Icons.h"
#include "event.h"

extern GtkWidget * lpWin;
extern GtkWidget * lpFixed;
extern GtkWidget * lpDlg;
extern GtkWidget * lpDisplay;
extern GdkColor    Colors[3];

int CreateWindow(void)
{
  GtkStyle      * lpStyle;
  GtkWidget     * lpMenuBar, * lpMenuItem, *lpMenu;
  GtkWidget     * lpTmp;
  GtkAccelGroup * lpAccel;

  int iVOffset = 66;
  int iHOffset = 4;

  int iRet = FALSE;
  int i;

  if((lpAccel = gtk_accel_group_new()) == NULL)
    goto end;
  if((lpWin = gtk_window_new(GTK_WINDOW_TOPLEVEL)) == NULL)
    goto end;
	gtk_signal_connect(GTK_OBJECT (lpWin), "delete-event",
                     GTK_SIGNAL_FUNC (CanClose), NULL);
  gtk_container_set_border_width(GTK_CONTAINER(lpWin), 0);
  gtk_window_set_policy(GTK_WINDOW(lpWin), FALSE, FALSE, FALSE);

  if((lpFixed = gtk_fixed_new()) == NULL)
    goto end;
  gtk_widget_ref(lpFixed);
 	gtk_object_set_data_full(GTK_OBJECT(lpWin), "Controls", lpFixed,
                          (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(lpFixed);
  gtk_container_add(GTK_CONTAINER(lpWin), lpFixed);
	gtk_widget_set_usize(lpFixed, 246, 374);

  if((lpMenuBar = gtk_menu_bar_new()) == NULL)
    goto end;
  gtk_fixed_put(GTK_FIXED(lpFixed), lpMenuBar, 0, 0);
  gtk_widget_show(lpMenuBar);
	gtk_widget_set_usize(lpMenuBar, 246, 24);

  if((lpMenu = gtk_menu_new()) == NULL)
    goto end;

  if((lpMenuItem = gtk_menu_item_new_with_label("Cut   Ctrl+X")) == NULL)
    goto end;
  gtk_widget_show(lpMenuItem);
  gtk_menu_append(GTK_MENU(lpMenu), lpMenuItem);
  gtk_signal_connect(GTK_OBJECT(lpMenuItem), "activate", GTK_SIGNAL_FUNC(MenuHandler), (void*)MENU_CUT);

  if((lpMenuItem = gtk_menu_item_new_with_label("Copy  Ctrl+X")) == NULL)
    goto end;
  gtk_widget_show(lpMenuItem);
  gtk_menu_append(GTK_MENU(lpMenu), lpMenuItem);
  gtk_signal_connect(GTK_OBJECT(lpMenuItem), "activate", GTK_SIGNAL_FUNC(MenuHandler), (void*)MENU_COPY);

  if((lpMenuItem = gtk_menu_item_new_with_label("Paste Ctrl+V")) == NULL)
    goto end;
  gtk_widget_show(lpMenuItem);
  gtk_menu_append(GTK_MENU(lpMenu), lpMenuItem);
  gtk_signal_connect(GTK_OBJECT(lpMenuItem), "activate", GTK_SIGNAL_FUNC(MenuHandler), (void*)MENU_PASTE);

  if((lpMenuItem = gtk_menu_item_new_with_label("Edit")) == NULL)
    goto end;
  gtk_widget_show(lpMenuItem);
  gtk_menu_bar_append(GTK_MENU_BAR(lpMenuBar), lpMenuItem);
  gtk_menu_item_set_submenu(GTK_MENU_ITEM(lpMenuItem), lpMenu);

  if((lpMenuItem = gtk_menu_item_new_with_label("About")) == NULL)
    goto end;
  gtk_widget_show(lpMenuItem);
  gtk_menu_bar_append(GTK_MENU_BAR(lpMenuBar), lpMenuItem);
  gtk_menu_item_right_justify(GTK_MENU_ITEM(lpMenuItem));
  gtk_signal_connect(GTK_OBJECT(lpMenuItem), "activate", GTK_SIGNAL_FUNC(MenuHandler), (void*)MENU_ABOUT);


  if((lpTmp = gtk_frame_new(NULL)) == NULL)
    goto end;
  gtk_frame_set_shadow_type(GTK_FRAME(lpTmp), GTK_SHADOW_IN);
  gtk_fixed_put(GTK_FIXED(lpFixed), lpTmp, 0, 28);
	gtk_widget_set_usize(lpTmp, 245, 30);
  gtk_widget_show(lpTmp);

  if((lpDisplay = gtk_drawing_area_new()) == NULL)
    goto end;
  gtk_container_add(GTK_CONTAINER(lpTmp), lpDisplay);
  gtk_widget_show(lpDisplay);
  gtk_widget_show(lpWin);

  lpStyle = gtk_widget_get_style(lpWin);

  for(i = 0; i < 42; i++)
  {
    char strTmp[100];

    GtkWidget * lpPixMapWid;
    GdkPixmap * lpPixMap;
    GdkBitmap * lpMask;

/*    if((lpPixMap = gdk_pixmap_create_from_xpm(lpWin->window, &lpMask,
                                          &lpStyle->bg[GTK_STATE_NORMAL],
                                          str2ndIcons[i])) == NULL)
*/
    if((lpPixMap = gdk_pixmap_create_from_xpm_d(lpWin->window, &lpMask,
                                                &lpStyle->bg[GTK_STATE_NORMAL],
                                                (gchar**) l_xpm[i + 1])) == NULL)
    {
      g_print("CreatePixMap\n");
      goto end;
    }
    if((lpPixMapWid = gtk_pixmap_new(lpPixMap, lpMask)) == NULL)
    {
      g_print("CreatePixMapWid\n");
      goto end;
    }
  	gtk_widget_show(lpPixMapWid);
    gtk_misc_set_alignment(GTK_MISC(lpPixMapWid), 0, 0);
    gtk_widget_ref(lpPixMapWid);
    sprintf(strTmp, "Label: %04i", i);
    gtk_object_set_data_full(GTK_OBJECT(lpWin), strTmp, lpPixMapWid,
                            (GtkDestroyNotify) gtk_widget_unref);
    if(i < 24)
      gtk_fixed_put(GTK_FIXED(lpFixed), lpPixMapWid, (i % 6) * 40 + 2 + iHOffset, (i / 6) * 39 + iVOffset);
    else
      gtk_fixed_put(GTK_FIXED(lpFixed), lpPixMapWid, (i % 6) * 40 + 2 + iHOffset, (i / 6) * 47 - 24 + iVOffset);
   	gtk_widget_set_usize(lpPixMapWid, 30, 13);
    gtk_widget_show(lpPixMapWid);
    gdk_pixmap_unref(lpPixMap);
    gdk_bitmap_unref(lpMask);
  }
  for(i = 0; i < 42; i++)
  {
    char strTmp[100];

    GtkWidget * lpTmp;
    GtkWidget * lpPixMapWid;
    GdkPixmap * lpPixMap;
    GdkBitmap * lpMask;

    sprintf(strTmp, "Button: %04i", i);
    if((lpTmp = gtk_button_new()) == NULL)
      goto end;
    GTK_WIDGET_UNSET_FLAGS(lpTmp, GTK_CAN_FOCUS);
    gtk_widget_ref(lpTmp);
    gtk_object_set_data_full(GTK_OBJECT(lpWin), strTmp, lpTmp,
                            (GtkDestroyNotify) gtk_widget_unref);
  	gtk_widget_show(lpTmp);
    if(i < 18)
    {
      gtk_fixed_put(GTK_FIXED(lpFixed), lpTmp, (i % 6) * 40 + iHOffset, (i / 6) * 39 + 15 + iVOffset);
     	gtk_widget_set_usize(lpTmp, 38, 21);
    }
    else
    {
      gtk_fixed_put(GTK_FIXED(lpFixed), lpTmp, (i % 6) * 40 + iHOffset, (i / 6) * 47 - 9 + iVOffset);
     	gtk_widget_set_usize(lpTmp, 38, 30);
    }
/*    if((lpPixMap = gdk_pixmap_create_from_xpm(lpTmp->window, &lpMask,
                                          &lpStyle->bg[GTK_STATE_NORMAL],
                                          strButtIcons[i])) == NULL)
*/
    if((lpPixMap = gdk_pixmap_create_from_xpm_d(lpWin->window, &lpMask,
                                                &lpStyle->bg[GTK_STATE_NORMAL],
                                                (gchar**) b_xpm[i + 1])) == NULL)
    {
      g_print("Create\n");
      goto end;
    }
    if((lpPixMapWid = gtk_pixmap_new(lpPixMap, lpMask)) == NULL)
      goto end;
    gtk_misc_set_alignment(GTK_MISC(lpPixMapWid), 0, 0);
    gtk_container_add(GTK_CONTAINER(lpTmp), lpPixMapWid);
    gtk_widget_show(lpPixMapWid);
	  gtk_signal_connect(GTK_OBJECT(lpTmp), "clicked", GTK_SIGNAL_FUNC(Clicked), (void*) i);
    gdk_pixmap_unref(lpPixMap);
    gdk_bitmap_unref(lpMask);
  }
  if(!gdk_color_parse("Blue", &Colors[0]))
    if(!gdk_color_parse("Black", &Colors[0]))
      goto end;
  if(!gdk_colormap_alloc_color(gdk_colormap_get_system(), &Colors[0], FALSE, TRUE))
    goto end;
  if(!gdk_color_parse("Green", &Colors[1]))
    if(!gdk_color_parse("Black", &Colors[1]))
      goto end;
  if(!gdk_colormap_alloc_color(gdk_colormap_get_system(), &Colors[1], FALSE, TRUE))
    goto end;
  if(!gdk_color_parse("Red", &Colors[2]))
    if(!gdk_color_parse("Black", &Colors[2]))
      goto end;
  if(!gdk_colormap_alloc_color(gdk_colormap_get_system(), &Colors[2], FALSE, TRUE))
    goto end;
//  RefreshDisplay();
	gtk_signal_connect(GTK_OBJECT (lpDisplay), "expose-event",
                     GTK_SIGNAL_FUNC (ShowHandler), NULL);
  gtk_accel_group_attach(lpAccel, GTK_OBJECT(lpWin));
  gtk_signal_connect (GTK_OBJECT (lpWin), "key_press_event",
                      GTK_SIGNAL_FUNC (KeyHandler),
                      NULL);
  iRet = TRUE;
end:
  if(!iRet)
    g_print("Error: CreateWindow\n");
  return iRet;
}
